\documentclass[a4paper,14pt]{extarticle}

\usepackage{lineno,hyperref}
\usepackage{amsfonts,amssymb,amsmath,textcomp}
\usepackage{color}
\usepackage{listings}
\usepackage{xspace}
\usepackage{comment}
\usepackage{verbatim}
\begin{document}
\section{Prerequisites}
The following libraries are necessary for using of PGIEM2G:
\begin{itemize}
	\item {\color{red} MPI subsystem} PGIEM2G needs at least TWO processes to work!
	\item FFTW3 (http://www.fftw.org/download.html) It \textit{must} be built with MPI and OpenMP support i.e. with (\verb|--enable-mpi --enable-openmp|)
	\item OpenBlas (https://github.com/xianyi/OpenBLAS) (recommended) or other modern implementation of BLAS/LAPACK
\end{itemize}
\section{Installation}
\subsection{For Linux}
Prepare a file, say \verb|make_conf.inc|, with all neccessary options like compliler, compilers flags, and paths to libraries (see \verb|make.template| as example)

\begin{verbatim} 
FC=
FC_Link= 

FOPTS= 
Ar=

LIB_FFTW= <PATH_TO_FFTW>/lib -lfftw3_omp -lfftw3_mpi  -lfftw3 
LIB_BLAS= <PATH_TO_BLAS>/lib -lopenblas_omp
FFTW_INC=  <PATH_TO_FFTW>/include

INSTALL_PATH=
\end{verbatim}

\begin{itemize}
	\item Set your favorite \textit{MPI} Fortran compiler to \verb|FC, FC_Link|.
	\item Set optimization and linking options to \verb|FOPTS|. Note, that flags for the best performance  on your system can be found only by experiments.
	\item \textit{Note!} your compiler with your options must support preprocessing
	\item Set \verb|xiar| to \verb|AR| in case of using Intel compilers and \verb|ar| in other cases
	\item The \verb|<PATH_TO_FFTW>|, \verb|<PATH_TO_BLAS>| are paths to  FFTW3 and BLAS libraries correspondingly
	\item Set path for the output binary  into \verb|INSTALL_PATH|
\end{itemize}

To  build PGIEM2G run \verb|make -j   LOCAL_OPTIONS=make_conf.inc|. Of course you can have as many different configuration files as you want for different setups.

\subsection{For Windows}
I have never try to do it


\section{Usage}

 {\color{blue} \Large While the use of PGIEM2G as standalone code is still supported by maintaner, it is \textit{highly} recommended to use GEMMIE \url{https://gitlab.com/m.kruglyakov/gemmie} as frontend }

\begin{itemize}
	\item Example of input format (json-based): \verb|comm3d_nx22ny28nz6.json|
	\item Command to run: \verb| mpirun -n <NP> path-to-PGIEM2G/giem2g input.json|
	\item $Nx$, $Ny$ and \verb|<NP>| must be even and $2Ny$ must be divisible by \verb|<NP>| without reminder
\end{itemize}


\section{PGIEM2G Control Parameters Structures}
All control parameters are set in the input file which is the first argument of the pgiem2g. This file has json-like format, i.e. keys and values. See \verb|tests/comm3d_nx22ny28nz6.json| as example.


\subsection{Parameters to  control PGIEM2G behaviour}
\begin{itemize}
	\item ``Problem type'': can be ``MT'' (default), ``QUASI 1D'', ``DISTRIBUTED SOURCE'', and ``RHS''. Specify the type of problem to solve. ``MT'' means magnetottelurics, ``QUASI 1D'' means the field from distributed source in 1-D layer media, ``DISTRIBUTED SOURCE'' means full 3-D problem with distributed source. ``RHS'' means special case, when use provide RHS of the integral equation explicitly.
	\item  ``Save Solution'': \textit{true} or  \textit{false} if set to true, the electrical field in the anomaly expanded over piece-wise constant polynomial basis will be saved to disk for future use. By default, this option is set to true
	\item  ``Load Solution'': \textit{true} or  \textit{false} if set to true, the solver loads existing solution files generated in the previous step. By default, it is set to true;
	\item   ``Solve Equation'': \textit{true} or  \textit{false} if set to true calculate (by constructing and solving corresponding system of linear equations) the piece-wise polynomial approximation of the electrical field inside the anomaly. By default, this option is set to true
	\item   ``Recalculate Fields'': \textit{true} or  \textit{false} if set to true calculate electrical and magnetic fields at the receivers by using solution from previous option or from the loaded file. By default, this option is set to true

	\item   ``Compute only anomalous field'':\textit{true} or  \textit{false}, if set to true the normal field  will not be calculated. By default, this option is set to false.

	\item   ``Save only total field'': \textit{true} or  \textit{false}, if set to true  only the total fields  will  be saved to disk. By default, this option is set to false.
	\item  ``IE solver output'': ``.'',  Specifies the path to IE solver output. By default, it is set to ``.'', which means that outputs will be saved on the same folder in which PGIEM2G is \textit{run}
	\item ``IE solver input'': ``.'',  Specifies the path to the solutions from the previous runs or for the initial guess for IE solver. By default, it is set to ``.''
	\item ``EM output'': ``.``, Specifies path to store EM fields. By default, it is set to ``.''

\end{itemize}
\subsection{Modelling parameters}

\begin{itemize}
	\item

	      ``Polynomial orders'': \{ \par
	      ``X'': 0,\par
	      ``Y'': 0, \par
	      ``Z'': 0\par
	      \},\par
	      specifiy the polynomial orders used along the corresponding directions
	\item
	      ``Background'': \{ \par
	      ``Upper halfspace'': 1e-15,\par
	      ``Conductivity'': [\par
	      1e-15,\par
	      1e-05,\par
	      1e-05,\par
	      0.0001,\par
	      0.001\par
	      ], \par
	      ``Thickness'': [\par
	      1,\par
	      1000,\par
	      9000,\par
	      20000\par
	      ]\par
	      \},\par

	      The ``Background'' key specifies properties of the background layers. The ``Upper halfspace'' key specifies conductivity of the upper halfspace ($z~<~0$) i.e. air.	The ``Conductivity'' key specifies the conductivity values of background layers and the ``Thickness'' key specifies their thicknesses. The number of elements in the conductivity array can be at maximum equal to the number of elements in thickness array + 1.
	\item
	      ``Anomaly'': \{ \par
	      ``Nx'': 100, \par
	      ``Ny'': 100,\par
	      ``Nz'': 1,\par
	      ``dx'': 100000,\par
	      ``dy'': 100000,\par
	      ``zborders'': [\par
	      1,  1001\par
	      ],\par
	      ``Conductivity'': ``conductivity.dat''\par
	      \},\par
	      \begin{itemize}
		      \item ``Nx'', ``Ny'', ``Nz'' specify the number of cells in anomaly in the corresponding directions.
		      \item ``dx'' and ``dy'' specify sxtension, in meters, of cells in $x$, $y$-directions.
		      \item ``zborders'' specify the array containing $z$ coordinates of cells in $z$-direction. The lengths of this array should be $Nz+1$.
		      \item ``Conductivity'': Specifies the name of the ascii file contains the anomalous conductivity, structured into \textit{Nx}\textit{Ny} rows and \textit{Nz} columns, each one corresponding to one vertical layer.
	      \end{itemize}

	\item ``Frequencies'':[0.1, 1] \par
	      Is used in MT case \textit{only}.  Specify the frequency values for which problem will be solved
	\item ``Recievers'': [ \par
	      \{ \par
	      ``Depths'': [ \par
	      0\par
	      ],\par
	      ``Areas'': [ \par
	      \{ \par
	      ``xshift'': 0, \par
	      ``yshift'': 0 \par
	      \} \par
	      ] \par
	      \} \par
	      ],\par
	      ``Receivers'' specifies position of observation points. This is array of structures. The vertical and lateral postions  are specified in different ways.
	      \begin{itemize}
		      \item The array ``Depths'' define the vertical positions, in meters, of observation points.
		      \item ``xshift'' and ``yshift'': Define the shift, in meters and in $x$ and $y$ directions, of observation points from the center of anomaly cells. For any element of the ``Recievers'' array, PGIEM2G calculates all 6
		            components of electrical and magnetic fields in the $NxNy$ sites with following coordinates:  $(\frac{dx}{2}+xshift+dxI,\frac{y}{2}+yshift+dy J, depth)$, where  $I=0, \dots Nx$ and $J=0, \dots Ny$ .  It is highly recommended to set non zero values to ``xshift'' and ``yshift'' only when the high-order polynomials in lateral direction are in use.
	      \end{itemize}
	\item
	      ``FGMRES'': \{ \par
	      ``OuterBufferSize'': 100, \par
	      ``InnerBufferSize'': 100, \par
	      ``MaxRestart'': 300, \par
	      ``Tolerance'': 1e-06 \par
	      \} \par
	      Parameters controlling the Flexible Generalized Minimal Residual Method (FGMRES) used to solve the linear system of equations in PGIEM2G. It is not recommended to change these parameters, except for experienced users.
\end{itemize}
\subsection{Non-MT cases}
\begin{itemize}
	\item
	      ``Source Domain'': \{ \par
	      ``Type'': 4,\par
	      ``Nx'': 200,\par
	      ``Ny'': 200,\par
	      ``Nz'': 1,\par
	      ``dx'': 100000,\par
	      ``dy'': 100000,\par
	      ``zborders'': [\par
	      0, 0.01\par
	      ]\par
	      \}, \par
	      Specify the location of the extraneous currents for ``QUASI 1D'' and ``DISTRIBUTED SOURCE'' cases. If ``Type'' is 1 then source domain has the same lateral position as anomaly. If ``Type'' is 4 than anomaly is located below the middle part of the source domain and has the twice less size in each directions. Other keys have the same meaning as for ``Anomaly''. Note, that if ``Type'' is 4 it is up to user to specify correct (different) values for $Nx$ and $Ny$ to ``Source Domain'' and ``Anomaly''.

	\item

	      ``Sources'': [ \par
	      \{ \par
	      ``Path'': ``uniform.bin'', \par
	      ``Frequency'': 0.001 \par
	      \}, \par

	      \{ \par
	      ``Path'': ``nonuniform.bin'', \par
	      ``Frequency'': 0.00001 \par
	      \}, \par
	      ], \par
	      Specify the local paths to the binary files contains the extraneous currents at corresponding frequencies.
\end{itemize}
\end{document}
